﻿using System;
using System.Collections.Generic;

namespace XamDataGridFilterTest.Grid.ViewModels
{
    public class ControlItem
    {
        public int WmsOrderId { get; set; }
        public int TmsOrderId { get; set; }
        public int TmsServiceId { get; set; }
        public string RefNr { get; set; }
        public string AccountShortName { get; set; }
        public DateTime Entry { get; set; }
        public DateTime? Start { get; set; }

        public int EntryDelta { get; set; }
        public int EntryOrStartDelta { get; set; }
        public DateTime? StartLocal { get; set; }

        public DateTime? Confirm { get; set; }
        public DateTime? Pickup { get; set; }
        public int EtaDelta { get; set; }
        public int PickupDelta { get; set; }

        public string EtaDeltaColor { get; set; }
        public string PickupDeltaColor { get; set; }
        public string WmsNextActionColor { get; set; }
        public string ConfirmColor { get; set; }

        public DateTime? Eta { get; set; }
        public DateTime? DeliverTime { get; set; }
        public string ServiceLevelCode { get; set; }
        public string LineType { get; set; }
        public string LineStatus { get; set; }
        public string TmsStatus { get; set; }
        public int TmsStatusId { get; set; }
        public int WmsNextAction { get; set; }

        public string CountryCode { get; set; }
        public string City { get; set; }
        public double GmtOffset { get; set; }
        public string LineToWhs { get; set; }

        public int LineTypeId { get; set; }
        public int LineStatusWeight { get; set; }
        public string LineStatusColor { get; set; }
        public bool LineAllocatedIsInbound { get; set; }
        public string LineAllocatedSsl { get; set; }
        public int LineAllocatedServiceId { get; set; }
        public string LineAllocatedPhone { get; set; }
        public int LineAllocatedFeedbackId { get; set; }

        public string LineToSsl { get; set; }
        public int LineToServiceId { get; set; }
        public int LineToFeedbackId { get; set; }

        public string TotalStatusColor { get; set; }
        public string TotalStatus { get; set; }
        public int TotalStatusWeight { get; set; }
        public string TotalFrom { get; set; }
        public string TotalTo { get; set; }

        public string TrackingNr { get; set; }
        public string Pod { get; set; }
        public DateTime? PodTime { get; set; }
        public DateTime? FromDate { get; set; }
        public DateTime? ToDate { get; set; }
        public double Km { get; set; }
        public string ToTimeZone { get; set; }
        public string FromTimeZone { get; set; }
        public int ToTimeZoneId { get; set; }
        public int FromTimeZoneId { get; set; }
        public List<ControlItem> Lines { get; set; }

        public bool SupportsPickup { get; set; }
        public string NoteSubject { get; set; }

        public string LineToFeedbackName
        {
            get
            {
                switch (LineToFeedbackId)
                {
                    case 1:
                        return "System access";
                    case 2:
                        return "Integration";
                    case 3:
                        return "Via vendor CT";
                    case 4:
                        return "WD – system access";
                    case 5:
                        return "WD – integration";
                    case 6:
                        return "WD – via vendor CT";
                    default:
                        return "No access";
                }
            }
        }

        public string LineAllocatedFeedbackName
        {
            get
            {
                switch (LineAllocatedFeedbackId)
                {
                    case 1:
                        return "System access";
                    case 2:
                        return "Integration";
                    case 3:
                        return "Via vendor CT";
                    case 4:
                        return "WD – system access";
                    case 5:
                        return "WD – integration";
                    case 6:
                        return "WD – via vendor CT";
                    default:
                        return "No access";
                }
            }
        }
    }
}
